<template>
  <v-list :items="items" select-strategy="classic" item-props>
    <template #item="{ props }">
      <v-list-item
        :title="props?.title"
        :density="props?.density"
        :min-height="props?.minHeight"
        :subtitle="props?.subtitle"
        :value="props?.value"
        :lines="props?.lines ? props?.lines : false"
      >
        <template v-if="props?.leading !== 'none'" #prepend="{ isActive, isSelected, isIndeterminate, select }">
          <v-list-item-action v-if="props?.leading === 'checkbox'">
            <svn-pro-checkbox
              :model-value="!isActive"
              :color="props?.leadingColor"
            />
          </v-list-item-action>
          
          <v-list-item-action v-if="props?.leading === 'icon'">
            <div>
              <Icon
                height="24"
                width="24"
                :icon="props?.leadingIcon"
              />
            </div>
          </v-list-item-action>
  
          <v-list-item-action v-if="props?.leading === 'switch'">
            <svn-pro-switch
              :value="isActive"
              :color="props?.leadingColor"
            />
          </v-list-item-action>
  
          <v-list-item-action v-if="props?.leading === 'radio'">
            <svn-pro-radio-button
              :value="isActive"
              :color="props?.leadingColor"
            />
          </v-list-item-action>
  
          <v-list-item-action v-if="props?.leading === 'avatar'">
            <svn-pro-avatar
              :type="props?.leadingMedia ? 'photo' : 'monogram'"
              :image="props?.leadingMedia"
              :firstname="props?.leadingFirstname"
              :size="40"
            />
          </v-list-item-action>
  
          <v-list-item-action v-if="props?.leading === 'image'" start>
            <v-img
              cover
              :width="56"
              :height="56"
              aspect-ratio="1/1"
              :src="props?.leadingMedia"
              :lazy-src="props?.leadingMedia"
            />
          </v-list-item-action>
  
          <v-list-item-action v-if="props?.leading === 'video'" start>
            <v-img
              cover
              :width="114"
              :height="64"
              aspect-ratio="16/9"
              :src="props?.leadingMedia"
              :lazy-src="props?.leadingMedia"
            />          
          </v-list-item-action>
        </template>
  
        <template v-if="props?.trailing !== 'none'" #append="{ isActive, isSelected, isIndeterminate, select }">
          <v-list-item-action v-if="props?.trailing === 'checkbox'">
            <svn-pro-checkbox
              :value="isActive"
              :color="props?.trailingColor"
            />
          </v-list-item-action>
          
          <v-list-item-action v-if="props?.trailing === 'icon'">
            <div>
              <Icon
                height="24"
                width="24"
                :icon="props?.trailingIcon"
              />
            </div>
          </v-list-item-action>
  
          <v-list-item-action v-if="props?.trailing === 'switch'">
            <svn-pro-switch
              :value="isActive"
              :color="props?.trailingColor"
            />
          </v-list-item-action>
  
          <v-list-item-action v-if="props?.trailing === 'radio'">
            <svn-pro-radio-button
              :value="isActive"
              :color="props?.trailingColor"
            />
          </v-list-item-action>
        </template>
      </v-list-item>
    </template>
  </v-list>
</template>

<script setup>
import { Icon } from "@iconify/vue";
import SvnProSwitch from "../../components/input/SvnProSwitch.vue";
import SvnProAvatar from "../../components/avatar/SvnProAvatar.vue";
import SvnProCheckbox from "../../components/input/SvnProCheckbox.vue";
import SvnProRadioButton from "../../components/input/SvnProRadioButton.vue";

const props = defineProps({
  items: {
    type: Array,
    default: () => [],
  },
});
</script>